/*
 * USB Driver for ALi m5602 based webcams
 *
 * Copyright (C) 2008 Erik Andrén
 * Copyright (C) 2007 Ilyes Gouta. Based on the m5603x Linux Driver Project.
 * Copyright (C) 2005 m5603x Linux Driver Project <m5602@x3ng.com.br>
 *
 * Portions of code to USB interface and ALi driver software,
 * Copyright (c) 2006 Willem Duinker
 * v4l2 interface modeled after the V4L2 driver
 * for SN9C10x PC Camera Controllers
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, version 2.
 *
 */

#ifndef M5602_V4L2_H_
#define M5602_V4L2_H_

#include "m5602_sensor.h"

#define VIDIOC_S_CTRL_OLD _IOW('V', 28, struct v4l2_control)

extern unsigned int debug;

int check_format(struct v4l2_format *fmt);

u32 m5602_request_buffers(struct m5602_camera *cam, u32 count);
void m5602_release_buffers(struct m5602_camera *cam);
void m5602_empty_framequeues(struct m5602_camera *cam);
int m5602_start_transfer(struct m5602_camera *cam);
int m5602_stop_transfer(struct m5602_camera *cam);
int m5602_stream_interrupt(struct m5602_camera *cam);
void m5602_vm_open(struct vm_area_struct *vma);
void m5602_vm_close(struct vm_area_struct *vma);
int m5602_v4l_open(struct inode *inode, struct file *filp);
int m5602_v4l_release(struct inode *inode, struct file *filp);
int m5602_v4l_mmap(struct file *filp, struct vm_area_struct *vma);
int m5602_v4l_ioctl(struct inode *inode, struct file *file,
		    unsigned int cmd, unsigned long arg);
int m5602_v4l_do_ioctl(struct inode *inode,
		       struct file *file,
		       unsigned int ioctlnr,
		       void *arg);

void m5602_urb_complete(struct urb *urb);

int m5602_probe_sensor(struct m5602_camera *cam);
int m5602_initialize_camera(struct m5602_camera *cam);

#endif
